import { Loadable } from 'use-async-reducer';
export interface UseAsyncCallOptions<T> {
    initialValue?: T;
    onSuccess?(data?: T): void;
    onFailure?(error?: Error): void;
    onComplete?(): void;
}
export interface UseAsyncCallUpdateOptions<T> {
    throwError?: boolean;
    saveError?: boolean;
    onSuccess?(data?: T): void;
    onFailure?(error?: Error): void;
    onComplete?(): void;
}
export declare type UseAsyncCallUpdater<T> = (asyncUpdater: Promise<T> | (() => Promise<T>), updateOptions?: UseAsyncCallUpdateOptions<T>) => Promise<T | undefined>;
export declare type UseAsyncCellReturnType<T> = [Loadable<T>, UseAsyncCallUpdater<T>];
export default function useAsyncCall<T extends any>(asyncCreator: () => Promise<T>, options?: UseAsyncCallOptions<T>): UseAsyncCellReturnType<T>;
